#include <stdio.h>
#include <GL/glut.h>
#include <math.h>

const int chekor=9;
float agolX=0;
float agolY=0;
float agolZ=0;
float transZ=50;
float rotateA=0;
float rotateAspeed=0.0f;
int polygonMode=GL_FILL;

float svX=0, svY=0, svZ=10;

void kocka (void) // ova e objektot koj go pretstavuva svetloto
{
   int i, j;

   glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
   glFrontFace(GL_CW);

   glColor3f(1,1,1);
   glBegin(GL_QUADS);
	glNormal3f(0,0,1);   // za sekoj poedinechen poligon mora da se navede vektor
                         // koj e normalen na ramninata na poligonot, za da se znae
                         // vo koj pravec se odbiva svetloto
      glVertex3f(-10,10,0);
      glVertex3f(10,10,0);
      glVertex3f(10,-10,0);
      glVertex3f(-10,-10,0);


      glNormal3f(0,0,-1);
      glVertex3f(-10,-10,13);
      glVertex3f(-10,10,13);
      glVertex3f(10,10,13);
      glVertex3f(10,-10,13);

      glNormal3f(0,1,0);
      glVertex3f(-10,-10,0);
      glVertex3f(-10,-10,13);
      glVertex3f(10,-10,13);
      glVertex3f(10,-10,0);

      glNormal3f(-1,0,0);
      glVertex3f(10,10,0);
      glVertex3f(10,-10,0);
      glVertex3f(10,-10,13);
      glVertex3f(10,10,13);

      glNormal3f(0,-1,0);
      glVertex3f(10,10,0);
      glVertex3f(10,10,13);
      glVertex3f(-10,10,13);
      glVertex3f(-10,10,0);

      glNormal3f(1,0,0);
      glVertex3f(-10,10,0);
      glVertex3f(-10,10,13);
      glVertex3f(-10,-10,13);
      glVertex3f(-10,-10,0);
   glEnd();
}

void mrezha (float chekori) {

   glFrontFace(GL_CCW);
   glBegin(GL_QUADS);
      glNormal3f(0,0,1); // edna zaednichka normala za site chetiriagolnici od mrezhata
      float i=0;
      float j=0;
      for ( i=0; i<chekori; i++)
      {
        for ( j=0; j<chekori; j++)
        {
          glVertex3f(i/chekori + 0,         j/chekori+0,        0);
          glVertex3f(i/chekori + 1/chekori, j/chekori+0,        0);
          glVertex3f(i/chekori + 1/chekori, j/chekori+1/chekori,0);
          glVertex3f(i/chekori + 0,         j/chekori+1/chekori,0);
        }
      }
   glEnd();
}

void skalilo_bezier (void) {
    glFrontFace(GL_CW);
    glPushMatrix();
    glScalef(0.1,0.02,0.1);
    glRotatef(0,0,1,0);
    GLint nNumPoints = 3;
    GLfloat ctrlPoints[3][3][3]= {{
        { 0.0f, 0.0f, 0.0f},
        { 0.0f, 0.0f, 0.0f},
        { 0.0f, 0.0f, 0.0f }},

        {
        { -3.0f, 0.0f, -4.0f},
        {  0.0f, 4.0f, -7.0f},
        {  3.0f, 0.0f, -4.0f }},

        {
        { -4.0f, 0.0f, -10.0f},
        {  0.0f, 0.0f, -10.0f},
        {  4.0f, 0.0f, -10.0f }}};
    glMap2f(GL_MAP2_VERTEX_3,
        0.0f,    10.0f,3,    3,
        0.0f,    10.0f, 9,    3,
    &ctrlPoints[0][0][0]);
    glEnable(GL_MAP2_VERTEX_3);
    glMapGrid2f(10,0.0f,10.0f,10,0.0f,10.0f);
    glEvalMesh2(GL_FILL,0,10,0,10);

    glPopMatrix();
}

void soba (void)
{
   float mat_ambient []={0.2f, 	0.2f, 	0.2f, 1.0f};
   float mat_diffuse []={0.8f, 	0.8f, 	0.8f, 1.0f};
   float mat_specular[]={0.2f, 	0.2f, 	0.2f, 1.0f};
   float mat_shininess = 0.25;

   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
   glMaterialf (GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);


    glFrontFace(GL_CCW);

   glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);

      // eden po eden zidovite od sobata
      glColor3f(0,0,0);
      glPushMatrix();
        glRotatef(180,0,1,0);
        glTranslatef(-50,-50,50);
        glScalef(10,10,10);
        glScalef(10,10,10);
        mrezha(10);
      glPopMatrix();

      glColor3f(1.0f,0.2f,0.2f);
      glPushMatrix();
        glTranslatef(-50,-50,-50);
        glRotatef(90,1,0,0);
        glScalef(10,10,10);
        glScalef(10,10,10);
        mrezha(10);
      glPopMatrix();

      glColor3f(1.0f,0.2f,0.1f);
      glPushMatrix();
        glTranslatef(-50,50,50);
        glScalef(10,10,10);
        glRotatef(-90,1,0,0);
        glScalef(10,10,10);
        mrezha(10);
      glPopMatrix();

      glColor3f(0.1f,0.1f,1.0f);
      glPushMatrix();
        glRotatef(90,0,1,0);
        glTranslatef(-50,-50,50);
        glScalef(10,10,10);
        glScalef(10,10,10);
        mrezha(10);
      glPopMatrix();

      glColor3f(1.0f,0.2f,0.0f);
      glPushMatrix();
        glTranslatef(-50,-50,-50);
        glRotatef(-90,0,1,0);
        glScalef(10,10,10);
        glScalef(10,10,10);
        mrezha(10);
      glPopMatrix();

      glColor3f(1.0f,1.0f,1.0f);
      glPushMatrix();
        glTranslatef(-50,-50,50);
        glScalef(10,10,10);
        glScalef(10,10,10);
        mrezha(10);
      glPopMatrix();
}

void skalila (float chekor)
{
   float mat_ambient []={0.2f, 	0.2f, 	0.2f, 1.0f};
   float mat_diffuse []={0.8f, 	0.8f, 	0.8f, 1.0f};
   float mat_specular[]={0.2f, 	0.2f, 	0.2f, 1.0f};
   float mat_shininess = 0.25;

   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
   glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

      float stepa=4.0*M_PI / chekor; // agol koj zafakja edna skala (2 kruga)
      float stepv=1.0 / (chekor+1);  // razlika vo visina na dve skalila
      float a=0;                     // pocheten agol za ciklusot

      /* aktiviraj izmeni na matrica za transformacii na prostorot.
       * transformaciite treba da se sfatat kako da se kontrolira robot koj
       * znae da crta.
       * Samiot robot e pochetokot na koordinatniot sistem.
       * Orientacijata na robotot desno mu e +x, levo -x,
       * gore mu e +y, dole mu e -y, napred e -z, nazad e +z.
       * Robot znae samo relativno da gleda vo odnos na sebe.
       * Koga se pravi nekakva transformacija vsushnost se pomestuva robotot,
       * zaedno so koordinatniot pochetok vo nekoja nova pozicija i potoa
       * crtanjeto pochnuva od tamu.
       */
      glMatrixMode(GL_MODELVIEW);

      /* stavi ja tekovnata matrica na stack
       * shto e isto kako da mu kazheme na robotot zapamti kade si se naogjal,
       * kon kade si bil orientiral
       */
      glPushMatrix();

      /* robotot odi pogore za pola chekor da pochne malku pogore prvataskala */
      glTranslatef(0,stepv,0);

      /* ciklus 2 svrtuvanja okolu kruzhnica, vo nekolku chekori:
       * vo sekoj chekor robotot kje iscrta edna skala, pa kje se svrti malku
       * vo prostorot i kje otide pogore vo prostorot za da bide tochno
       * pozicioniran za crtanje na slednata skala
       */
      glColor3f( 0.5f,0.5f,0.5f);
      while ( a <= 4.0*M_PI ) {

         /* nacrtaj triagolnik so bojata da se menuva po sekoj chekoj
          * triagolnikot e vpishan vo kruzhnica so radius 1
          */
         /*glBegin(GL_TRIANGLES);
            glNormal3f(0,1,0);
            glVertex3f(0,0,0);
            glVertex3f(1,0,0);
            glVertex3f(cos(stepa),0,sin(stepa));
         glEnd();
         */
         skalilo_bezier();

         /* robotot se svrtuva tochno za agolot kolku shto e edna skala,
          * no ovde, za razlika od cos, sin, se potrebni stepeni, a ne radijani
          * svrtuvanjeto e okolu oska shto trgnuva od (0,0,0)-(0,1,0) a toa e
          * faktichki samata y-oska
          */
         glRotatef(stepa * 180.0/M_PI, 0,1,0);

         /* robotot odi pogore za edna skala */
         glTranslatef(0,stepv,0);


         a+=stepa;
      }
      glPopMatrix(); // vrati se na poslednata zapamtena pozicija na robotot
}

/* procedura za iscrtuvanje na eden stolb so visina 1 i radius 1 (cilindar) */
void stolb (float chekor)
{
   float mat_ambient []={0.2f, 	0.2f, 	0.2f, 1.0f};
   float mat_diffuse []={0.8f, 	0.8f, 	0.8f, 1.0f};
   float mat_specular[]={0.2f, 	0.2f, 	0.2f, 1.0f};
   float mat_shininess = 0.25;

   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
   glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

      float stepa=2.0 * M_PI/chekor;
      float a=0.0;


      glFrontFace(GL_CW);

      glMatrixMode(GL_MODELVIEW);
      glPushMatrix();
      while ( !( a > 2.0*M_PI ) ) {
         /* slichno kako kaj skalite, no se koristat chetiriagolnici */
         glBegin(GL_QUADS);
            glColor3f(0.03f,0.03f,0.03f);

            glNormal3f(1,0,0);
            glVertex3f(1,0,0);

            glNormal3f(cos(stepa),0,sin(stepa));
            glVertex3f(cos(stepa),0,sin(stepa));

            glNormal3f(cos(stepa),0,sin(stepa));
            glVertex3f(cos(stepa),1,sin(stepa));

            glNormal3f(1,1,0);
            glVertex3f(1,1,0);
         glEnd();
         glRotatef(stepa*180.0/M_PI,0,1,0);
         a+=stepa;
      }
      glPopMatrix();
}

void predmetiVoSoba(void) {
    glPushMatrix();
    glTranslatef(-25,-50,-25);
    glScalef(3,100,3);
    stolb(17);
    glScalef(5,1,5);
    skalila(15);
    glPopMatrix();

    glPushMatrix();
    glTranslatef(-25,-50,25);
    glScalef(3,100,3);
    stolb(17);
    glScalef(5,1,5);
    skalila(15);
    glPopMatrix();

    glPushMatrix();
    glTranslatef(25,-50,25);
    glScalef(3,100,3);
    stolb(17);
    glScalef(5,1,5);
    skalila(15);
    glPopMatrix();

    glPushMatrix();
    glTranslatef(25,-50,-25);
    glScalef(3,100,3);
    stolb(17);
    glScalef(5,1,5);
    skalila(15);
    glPopMatrix();

}


void display(void)
{
   glPolygonMode(GL_FRONT_AND_BACK,polygonMode);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   //Mestenje pogled
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   gluLookAt(0,0,transZ,0,0,0,0,1,0);
   glRotatef(rotateA,0,1,0);

   // repozicioniranje na svetloto
   GLfloat svetlo0_position[]= {svX,svY,svZ,1};
   glLightfv(GL_LIGHT0,GL_POSITION,svetlo0_position);
   //GLfloat spotdir[]= {0,-20,0};
   //glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,spotdir);

   // crtanje na scenata
   glPushMatrix();
     glTranslatef(svX,svY,svZ);
     glScalef(0.4,0.4,0.4);
     kocka();
   glPopMatrix();

   soba();
   predmetiVoSoba();

   glFlush();

   // smeni buffer
   glutSwapBuffers();
}

void init (void)
{
   glClearColor(0.1f, 0.1f, 0.1f, 1.0f);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glFrustum(-10, 10, -10, 10, 10, 1000);

   glEnable(GL_DEPTH_TEST);

   glShadeModel(GL_SMOOTH);
   glEnable(GL_LIGHTING);
   glEnable(GL_COLOR_MATERIAL);

   // globalno svetlo
   GLfloat global_ambient[]= {0.2f,0.2f,0.2f,1};
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);

   glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
   glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

   // Svetlo 0
   GLfloat svetlo0_ambient[]=  {0.0f,0.0f,0.0f,1.0f };
   GLfloat svetlo0_diffuse[]=  {1.0f,1.0f,1.0f,1.0f };
   GLfloat svetlo0_specular[]= {1.0f,1.0f,1.0f,1.0f };
   glLightfv(GL_LIGHT0,GL_AMBIENT,svetlo0_ambient);
   glLightfv(GL_LIGHT0,GL_DIFFUSE,svetlo0_diffuse);
   glLightfv(GL_LIGHT0,GL_SPECULAR,svetlo0_specular);

   //glLightf(GL_LIGHT0,GL_SPOT_CUTOFF,40.0f);
   //glLighti(GL_LIGHT0,GL_SPOT_EXPONENT,10);

   glEnable(GL_LIGHT0);
}



void keyboard(unsigned char key, int x, int y)
{
   printf("%d %f %f %f %f \n", key, svX, svY, svZ, transZ);
   switch (key) {
      case 27:
         exit(0);
         break;
      case 'W':
         transZ+=0.5f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'S':
         transZ-=0.5f;
         if (transZ<0) transZ=0;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'w':
         transZ+=0.1f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 's':
         transZ-=0.1f;
         if (transZ<0) transZ=0;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'A':
         rotateAspeed+=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'a':
         rotateAspeed+=0.1f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'D':
         rotateAspeed-=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'd':
         rotateAspeed-=0.1f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '1':
         polygonMode=GL_LINE;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '2':
         polygonMode=GL_FILL;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'i':
         svY+=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'k':
         svY-=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'j':
         svX-=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'l':
         svX+=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'y':
         svZ+=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'h':
         svZ-=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
   }
}

void idle(void)
{
  rotateA+=rotateAspeed;
  glutPostRedisplay();
}

int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
   glutInitWindowSize (600, 500);
   glutInitWindowPosition (0, 0);
   glutCreateWindow ("Primer");
   init ();
   glutDisplayFunc(display);
   glutIdleFunc(idle); // ovaa funkcija treba da se povika koga programot ne pravi nishto
   glutKeyboardFunc(keyboard);  // Pri pritisok na tastaturata se povikuva keboard
   glutMainLoop();
   return 0;
}
